
#
# Killer
#
# plugin name:
#       Killer
#
# available options:
#       none
#
# available commands:
#       none
#
#
# Killer displays list of running processes that it gets with 
# "ps ax" command. SIGKILL (kill -9) is sent to PID of selected
# process.
#

#
# Copyright 2010 Igor Brkic <igor@hyperglitch.com>
#

class Killer

    def initialize io
        @io=io
    end

    def setup options
    end

    def run action=[]
        if action.empty? then
            procs={}
            `ps ax`.split("\n").reverse.each{ |p| 
                k=p.split[4..-1].join(' ')
                
                k=k[0..15]+'...' if k.length>18
                v=p.split[0]
                k+=" (#{v})"
                procs[k]=v    
            }

            resp=@io.input(procs.keys, '[Killer]')

            if procs.has_key?(resp) then
                resp=`kill -9 #{procs[resp]}`
                if resp!='' then
                    @io.output resp
                end
            else
                @io.output "[Killer] unknown process"
            end
        end
    end
end
